# 配置 Kudu

原文链接 : [http://kudu.apache.org/docs/configuration.html](http://kudu.apache.org/docs/configuration.html)

译文链接 : [http://cwiki.apachecn.org/pages/viewpage.action?pageId=10813616](http://cwiki.apachecn.org/pages/viewpage.action?pageId=10813616)

贡献者 : [小瑶](/display/~chenyao) [ApacheCN](/display/~apachecn) [Apache中文网](/display/~apachechina)

## 配置 Apache Kudu

注意

**Kudu** 与 **[Cloudera Manager](http://www.cloudera.com/content/www/en-us/products/cloudera-manager.html) **相比，在独立安装中更容易配置。有关使用 **Kudu** 与 **Cloudera Manager** 的更多详细信息，请参阅 **Cloudera** 的[ **Kudu** 文档](http://www.cloudera.com/documentation/kudu/latest/topics/kudu_installation.html)。

## 配置 Kudu

### 配置基础

要配置每个 **Kudu** 进程的行为，您可以在启动时传递命令行标志，或者通过使用一个或多个 **--flagfile = &lt;file&gt;** 选项传递它们从配置文件读取这些选项。您甚至可以在配置文件中包含 **--flagfile** 选项以包含其他文件。通过阅读 [其文档](https://gflags.github.io/gflags/) 了解有关 **gflags** 的更多信息。

您可以将 **masters** 和 **tablet servers** 的选项放置在相同的配置文件中，并且每个将忽略不适用的选项。

**Flags **可以以一个或两个字符为前缀。本文档标准化在两个：**--example_flag** 。

### 发现配置选项

只有最常见的配置选项在此记录。有关配置选项的更详尽的列表，请参阅 [配置参考](/pages/viewpage.action?pageId=10813644)。

要查看给定可执行文件的所有 **configuration flags** ( 配置标志 )，请使用 **--help** 选项运行它。配置未记录的标志时要小心，因为并非所有可能的配置都已经经过测试，并且无法保证在未来版本中保留未记录的选项。

### 配置 Kudu Master

要查看 **kudu-master** 可执行文件的所有可用配置选项，请使用 **--help** 选项运行它：

```
$ kudu-master --help
```

表1 . 支持 **Kudu Masters** 的配置标志

| Flag( 标记 ) | Valid Options ( 有效选项 ) | Default( 默认 ) | Description ( 说明 ) |
| --- | --- | --- | --- |
| --master_addresses | string | localhost | **Master** 共享配置的所有 **RPC** 地址的逗号分隔列表。如果未指定，假定为 **standalone Master** |
| --fs_data_dirs | string |   | **Master** 将放置其数据块的目录的逗号分隔列表。 |
| --fs_wal_dir | string |   | **Master** 将其预写日志的目录。可能与 ** --fs_data_dirs** 中列出的目录之一相同，但不能与数据目录的子目录相同。 |
| --log_dir | string | /tmp | 存储主日志文件的目录。 |

有关 **masters** 标志的完整列表，请参见 ["**Kudu Master** 配置参考"](/pages/viewpage.action?pageId=10813644) 。

### 配置 Tablet Servers

要查看 **kudu tserver** 可执行文件的所有可用配置选项，请使用 **--help** 选项运行它：

```
$ kudu-tserver --help
```

表2 . 支持 **Kudu Tablet Servers** 的配置标志

| Flag( 标记 ) | Valid Options ( 有效选项 ) | Default( 默认 ) | Description ( 说明 ) |
| --- | --- | --- | --- |
| --fs_data_dirs | string |   | **Tablet Server** 将放置其数据块的目录的逗号分隔列表。 |
| --fs_wal_dir | string |   | **Tablet Server** 将放置预写日志的目录。 可能与 **--fs_data_dirs** 中列出的目录之一相同，但不能与数据目录的子目录相同。 |
| --log_dir | string | /tmp | 存储 **Tablet Server** 日志文件的目录 |
| --tserver_master_addrs | string | 127.0.0.1:7051 | **tablet server** 应连接的主机的逗号分隔地址。 **masters** 不读这个标志。 |
| --block_cache_capacity_mb | integer | 512 | 分配给 **Kudu Tablet Server** 块缓存的最大内存量。 |
| --memory_limit_hard_bytes | integer | 4294967296 | **Tablet Server** 可以在开始拒绝所有传入写入之前消耗的最大内存量。 |

有关 tablet servers 的标志的完整列表，请参阅 ["**Kudu Tablet Server**配置参考"](/pages/viewpage.action?pageId=10813644) 。

## 下一步

*   [Kudu 入门指南](http://cwiki.apachecn.org/pages/viewpage.action?pageId=10813610)
*   [使用 Kudu 开发应用程序](http://cwiki.apachecn.org/pages/viewpage.action?pageId=10813629)